# frozen_string_literal: true

require 'rspec/unit_ext/expectation'

module RSpec
  module UnitExt
    class ExpectationGroup
      def initialize(example_group, *expectations, **attributes)
        @example_group = example_group
        @expectations = expectations.map do |expectation|
          expectation = Expectation.new example_group, expectation if expectation.is_a? Hash
          expectation.fill_attributes attributes

          expectation
        end
      end

      def run
        @expectations.each(&:run)
      end
    end
  end
end
